function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { Column, Entity, Index, JoinColumn, ManyToOne, PrimaryColumn } from "typeorm";
import { id } from "../id.js";
import { User } from "./user.js";
import { Memoriet } from "./memoriet.js";
export let MemorietView = class MemorietView {
    id;
    createdAt;
    viewedAt;
    memorietId;
    memoriet;
    viewerId;
    viewer;
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], MemorietView.prototype, "id", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone"),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], MemorietView.prototype, "createdAt", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone"),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], MemorietView.prototype, "viewedAt", void 0);
_ts_decorate([
    Index(),
    Column(id()),
    _ts_metadata("design:type", Object)
], MemorietView.prototype, "memorietId", void 0);
_ts_decorate([
    ManyToOne(()=>Memoriet, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], MemorietView.prototype, "memoriet", void 0);
_ts_decorate([
    Index(),
    Column(id()),
    _ts_metadata("design:type", Object)
], MemorietView.prototype, "viewerId", void 0);
_ts_decorate([
    ManyToOne(()=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], MemorietView.prototype, "viewer", void 0);
MemorietView = _ts_decorate([
    Entity("memoriet_view"),
    Index([
        "memorietId",
        "viewerId"
    ], {
        unique: true
    })
], MemorietView);
